package platform_user

import (
	"github.com/pkg/errors"
	pbMq "live-service/app/pb/mq"
)

// PlatformUser 仅提取需要的部分,其余的json后装到p_info
type (
	PlatformUser struct {
		PUid    string
		PName   string
		PAvatar string
		PInfo   string
	}
	UserRetriever struct {
		retrieveMapper map[string]RetrieveFunc
	}
)

type RetrieveFunc func(pUid string) (*PlatformUser, error)

func NewUserRetriever() *UserRetriever {
	return &UserRetriever{
		retrieveMapper: map[string]RetrieveFunc{
			pbMq.Platform_name[int32(pbMq.Platform_bilibili)]: RetrieveBilibili,
		},
	}
}

func (r *UserRetriever) RetrieveUser(platform, pUid string) (*PlatformUser, error) {
	if handle, ok := r.retrieveMapper[platform]; ok {
		return handle(pUid)
	}
	return nil, errors.New("没有此平台的用户数据收集器")
}
